//
//  SampleViewController.swift
//  Runner
//
//  Created by NUNC on 01/03/22.
//

import UIKit
import Flutter
import Alamofire


class SampleViewController: UIViewController{
    
    var carListArr:[[String:Any]] = []
    var callback:(String)->(Void)={_ in}

    override func viewDidLoad() {
        
        super.viewDidLoad()

        // Do any additional setup after loading the view.
//        UIFont.loadFont(
//            withFilenameString: "NunitoSans-SemiBold.ttf",
//            bundle: Bundle(for: type(of: self))
        
//        )
//        let fontFamilyNames = UIFont.familyNames
//
//        for familyName in fontFamilyNames {
//            print("Font Family Name = [\(familyName)]")
//            let names = UIFont.fontNames(forFamilyName: familyName)
//            print("Font Names = [\(names)]")
//        }
//        self.view.backgroundColor = .red
//        let image = UIImage(named: "Camera.png", in: Bundle(for: type(of: self)), compatibleWith: nil)
//
////        let image = UIImage.init(named: "Camera")
//        let imageView = UIImageView.init(image: image)
//        imageView.frame = CGRect.init(x: 50, y: 100, width: 100, height: 100)
//        self.view.addSubview(imageView)
//        let label = UILabel()
//        label.frame = CGRect.init(x: imageView.frame.minX, y: imageView.frame.maxY+20, width: 100, height: 20)
//        label.text = "Test"
//        label.font = UIFont(name: "NunitoSans-SemiBold", size: 40)
//        self.view.addSubview(label)
        let tableView = UITableView()
        tableView.frame = CGRect.init(x: 0, y: 0, width: self.view.frame.width, height: self.view.frame.height)
        self.view.addSubview(tableView)
        tableView.register(UINib.init(nibName: "CarTableViewCell", bundle: Bundle(for: type(of: self))), forCellReuseIdentifier: "CarTableViewCell")
        tableView.delegate = self
        tableView.dataSource = self
        
        
        
    }
    
    override func viewWillAppear(_ animated: Bool) {
        self.navigationController?.navigationBar.isHidden = false
        self.navigationController?.setNavigationBarHidden(false, animated: false)
    }
    
    override func viewWillDisappear(_ animated: Bool) {
        self.navigationController?.setNavigationBarHidden(true, animated: false)
    }
    

}

public extension UIFont {

    static func loadFont(withFilenameString:String,bundle:Bundle) {
        let bundleUrl = Bundle.init(identifier: "")
            if let fontUrl = bundle.url(forResource: withFilenameString, withExtension: "ttf"),
               let dataProvider = CGDataProvider(url: fontUrl as CFURL),
               let newFont = CGFont(dataProvider) {
                var error: Unmanaged<CFError>?
                if !CTFontManagerRegisterGraphicsFont(newFont, &error)
                    {
                        print("Error loading Font!")
                } else {
                    print("Loaded font")
                }
            } else {
                assertionFailure("Error loading font")
            }
        }
}

extension SampleViewController:UITableViewDelegate, UITableViewDataSource{
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
            return self.carListArr.count
        }
        
        // create a cell for each table view row
        func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
            
            // create a new cell if needed or reuse an old one
//            let cell:UITableViewCell = UITableViewCell()
            guard let cell = tableView.dequeueReusableCell(withIdentifier: "CarTableViewCell") as? CarTableViewCell else{
                return UITableViewCell()
            }
            let carItem = self.carListArr[indexPath.row]
            cell.carName.text = carItem["name"] as? String ?? ""
            cell.descriptionLbl.text = carItem["description"] as? String ?? ""
            cell.descriptionLbl.numberOfLines = 3
            // set the text from the data model
//            cell.textLabel?.text = "Car: \(carItem["name"] as? String ?? "")\n Description: \(carItem["description"] as? String ?? "")"
//            carItem["name"] as? String ?? ""
        
            return cell
        }
        
        // method to run when table view cell is tapped
        func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
            print("You tapped cell number \(indexPath.row).")
            let carItem = self.carListArr[indexPath.row]
            self.callback(carItem["name"] as? String ?? "")
            self.navigationController?.popViewController(animated: true)
        }
}
